#ifndef PGC_BINDING_H
#define PGC_BINDING_H

#include "pgc.h"

struct pgc_binding {
  char *binding_name;
  int value_type;
  void *value;
  int reference_count;
};

struct pgc_environment {
  int result_type;
  void *result;
  int top_level_result_type;
  void *top_level_result;
  struct pgc_binding **bindings;
  struct pgc_binding *result_binding;
};

void pgc_backup_result (struct pgc_environment *current_environment);

struct pgc_environment *pgc_copy_environment 
(struct pgc_environment *old_environment);

void pgc_free_vector (struct pgc_vector *dead_vector);
void pgc_free_record (struct pgc_record *dead_record);
void pgc_free_data (int type, void *data);

struct pgc_vector *pgc_copy_vector (struct pgc_vector *old_vector);

void *pgc_copy_data (int data_type, void *data);

struct pgc_binding *pgc_lookup_binding 
(char *binding_name, struct pgc_environment *current_environment);

/* This function will also replace any old bindings that it finds... */
struct pgc_environment *pgc_add_binding 
(struct pgc_binding *new_binding, struct pgc_environment *current_environment);

/* Because it's not always clear how to free things... */
void pgc_delete_environment (struct pgc_environment *dead_environment);

#endif
