#include <stdlib.h>
#include <string.h>
#include "pgc.h"
#include "pgc_conf.h"
#include "pgc_conf_lexer.h"
#include "pgc_hash.h"

extern struct pgc_conf_entry **conf_table;

void pgc_add_conf_entry (char *key, char *value) { 
  int i;
  int hashed_index = pgc_hash (key, PGC_CONF_TABLE_SIZE);
  int insertion_index = -1;
  for (i = hashed_index; i < PGC_CONF_TABLE_SIZE; i++) {
    if (conf_table[i] == NULL) {
      insertion_index = i;
      break;
    }
    if (strcmp (key, conf_table[i]->entry_name) == 0) {
      insertion_index = i;
      break;
    }
  }
  if (insertion_index == -1)
    for (i = hashed_index; i < PGC_CONF_TABLE_SIZE; i++) {
      if (conf_table[i] == NULL) {
	insertion_index = i;
	break;
      }
      if (strcmp (key, conf_table[i]->entry_name) == 0) {
	insertion_index = i;
	break;
      }
    }
  if (insertion_index != -1) {
    conf_table[insertion_index] = malloc (sizeof (struct pgc_conf_entry));
    conf_table[insertion_index]->entry_name = strdup (key);
    conf_table[insertion_index]->entry_value = strdup (value);
  }
  return;
}

char *pgc_lookup_conf_entry (char *key) {
  int i;
  int hashed_index = pgc_hash (key, PGC_CONF_TABLE_SIZE);
  for (i = hashed_index; i < PGC_CONF_TABLE_SIZE; i++) {
    if (conf_table[i] == NULL)
      return NULL;
    if (strcmp (key, conf_table[i]->entry_name) == 0)
      return conf_table[i]->entry_value;
  }
  for (i = 0; i < hashed_index; i++) {
    if (conf_table[i] == NULL)
      return NULL;
    if (strcmp (key, conf_table[i]->entry_name) == 0)
      return conf_table[i]->entry_value;
  }
  return NULL;
}
