#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include "pgc_function_interface_lsqrms.h"

void *pgc_interface_lsqrms (void **args) {
  int childpid;
  char *output_filename;
  int output_fd; 
  double *result = malloc (sizeof (double));
  *result = (double) -1.0;
  do {
    output_filename = strdup ("pgcXXXXXX");
    output_fd = mkstemp (output_filename);
  }
  while (output_fd == -1);
  close (output_fd);
  childpid = fork ();
  if (childpid == -1) {
    fprintf (stderr, "lsqrms: Could not fork off lsqrms process.\n");
    return result;
  }    
  if (childpid == 0) {
    char **outgoing_argv = malloc (sizeof (char *) * 4);
    outgoing_argv[0] = strdup (PGC_LSQRMS_FULL_PATH);
    outgoing_argv[1] = strdup ((char *) args[0]);
    outgoing_argv[2] = strdup ((char *) args[1]);
    outgoing_argv[3] = NULL;
    /* Reroute stdout... */
    if (freopen (output_filename, "w+", stdout) == NULL) {
      fprintf (stderr, "lsqrms_child: FATAL: Could not redirect stdout.\n");
      exit (1); /* Remember, this is a different process! */
    }
    if (execv (PGC_LSQRMS_FULL_PATH, outgoing_argv) == -1) {
      fprintf (stderr, "lsqrms_child: FATAL: \'%s\' could not be loaded.\n",
	       PGC_LSQRMS_FULL_PATH);
      exit (1);
    };
  }
  else {
    FILE *result_file;
    int success = 0;
    (void) waitpid (childpid, NULL, 0);
    result_file = fopen (output_filename, "r");
    if (result_file == NULL)
      fprintf (stderr, "lsqrms: Could not open file \'%s\' for reading.\n",
	       output_filename);
    else {
      do {
	char c;
	char *line_read = strdup ("");
	int eof_reached = 0;
	int line_length = 0;
	do {
	  if (fread (&c, sizeof (char), 1, result_file) == 1) {
	    line_read = 
	      (char *) realloc (line_read, sizeof (char) * (line_length + 2));
	    line_read[line_length] = c;
	    line_read[line_length + 1] = (char) 0;
	    line_length = strlen (line_read);
	  }
	  else {
	    eof_reached = 1;
	    break;
	  }
	}
	while (c != (char) '\n');
	if (eof_reached)
	  break;
	if (sscanf (line_read, "RMSmin = %lf", result) == 1) {
	  success = 1;
	  break;
	}
      }
      while (1);
    }
    if (unlink (output_filename) == -1)
      fprintf (stderr, "lsqrms: Unable to delete file \'%s\'.\n", 
	       output_filename);
  }
  return result;
}
